0%

Leetcode_797. 所有可能的路径

题目

797. 所有可能的路径
难度:中等

给你一个有 n 个节点的 有向无环图(DAG),请你找出所有从节点 0 到节点 n-1 的路径并输出(不要求按特定顺序

二维数组的第 i 个数组中的单元都表示有向图中 i 号节点所能到达的下一些节点,空就是没有下一个结点了。

译者注:有向图是有方向的,即规定了 a→b 你就不能从 b→a 。

 

示例 1:

输入:graph = [[1,2],[3],[3],[]]
输出:[[0,1,3],[0,2,3]]
解释:有两条路径 0 -> 1 -> 3 和 0 -> 2 -> 3

示例 2:

输入:graph = [[4,3,1],[3,2,4],[3],[4],[]]
输出:[[0,4],[0,3,4],[0,1,3,4],[0,1,2,3,4],[0,1,4]]

示例 3:

输入:graph = [[1],[]]
输出:[[0,1]]

示例 4:

输入:graph = [[1,2,3],[2],[3],[]]
输出:[[0,1,2,3],[0,2,3],[0,3]]

示例 5:

输入:graph = [[1,3],[2],[3],[]]
输出:[[0,1,2,3],[0,3]]

 

提示:

  • n == graph.length
  • 2 <= n <= 15
  • 0 <= graph[i][j] < n
  • graph[i][j] != i(即,不存在自环)
  • graph[i] 中的所有元素 互不相同
  • 保证输入为 有向无环图(DAG)

方法一: 回溯/深度优先搜索(DFS)

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class Solution:
def allPathsSourceTarget(self, graph: List[List[int]]) -> List[List[int]]:
n = len(graph)
ret = []

def backtrack(temp, node):
if node == n-1:
ret.append(temp[:])
return
for i in graph[node]:
temp.append(i)
backtrack(temp, i)
temp.pop()
backtrack([0], 0)
return ret

正常的回溯套路,需要注意的是:

  1. 每个列表apppend的时候到底加的是什么东西;
  2. 开头的0的加上;
  3. ret.append(temp[:])用这种方式可以解决深浅拷贝的问题。

方法二: 宽度优先搜索(BFS)

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
class Solution:
def allPathsSourceTarget(self, graph: List[List[int]]) -> List[List[int]]:
from queue import Queue
# 创建一个先进先出的队列
q = Queue()
n = len(graph)-1
ret = []
# 向队列中加入元素
q.put([0])
while not q.empty():
# 取出队列中的元素(因为是先进先出,所以是第一个)
tmp = q.get()
for i in graph[tmp[-1]]:
if i == n:
ret.append(tmp+[i])
continue
q.put(tmp+[i])
return ret

提交记录

提交记录.md.jpg